﻿-- author  Mythos
-- date  23/01/2012
-- www.ARM-Team.gr
-- Copyright (C) ARM Team, All Rights Reserved.

Ford8340 = {};

function Ford8340.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Steerable, specializations);
end;

function Ford8340:load(xmlFile)
	-- wheels
	self.frontLeft = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.twinWheels#frontLeft"))
	self.frontRight = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.twinWheels#frontRight"))
	self.backLeft = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.twinWheels#backLeft"))
	self.backRight = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.twinWheels#backRight"))

	setVisibility(self.frontLeft,false)
	setVisibility(self.frontRight,false)
	setVisibility(self.backLeft,false)
	setVisibility(self.backRight,false)
	-- function
	self.OPER= SpecializationUtil.callSpecializationsFunction("OPER");
end;

function Ford8340:delete()
end;
function Ford8340:mouseEvent(posX, posY, isDown, isUp, button)
end;
function Ford8340:keyEvent(unicode, sym, modifier, isDown)
end;

function Ford8340:update(dt)
	if self:getIsActive() then
		if InputBinding.hasEvent(InputBinding.RIGHTDOOR) then
			self:OPER(1, not self.rd);
		end;
		
		if InputBinding.hasEvent(InputBinding.LEFTDOOR) then
			self:OPER(2, not self.ld);
		end;
		
		if InputBinding.hasEvent(InputBinding.BACKWINDOW) then
			self:OPER(3, not self.bw);
		end;
		if InputBinding.hasEvent(InputBinding.TWINSFRONT) then
			self:OPER(4, not self.tf);
		end;
		if InputBinding.hasEvent(InputBinding.TWINSBACK) then
			self:OPER(5, not self.tb);
		end;
		
		if InputBinding.hasEvent(InputBinding.SHOWTKHELP) then
			self.showTKHelp = not self.showTKHelp;
		end;
	end;	
end;

function Ford8340:updateTick(dt)
end;
function Ford8340:draw()
	if self.showTKHelp then 
		g_currentMission:addHelpButtonText("Piilota komennot", InputBinding.SHOWTKHELP);
		g_currentMission:addHelpButtonText("Oikea ovi", InputBinding.RIGHTDOOR);
		g_currentMission:addHelpButtonText("Vasen ovi", InputBinding.LEFTDOOR);
		g_currentMission:addHelpButtonText("Takaikkuna", InputBinding.BACKWINDOW);
		g_currentMission:addHelpButtonText("Paripyörät etu", InputBinding.TWINSFRONT);
		g_currentMission:addHelpButtonText("Paripyörät taka", InputBinding.TWINSBACK);
	else
		g_currentMission:addHelpButtonText("Näytä komennot", InputBinding.SHOWTKHELP);
	end;
end;

function Ford8340:OPER(mode, state, noEventSend)
	Ford8340Event.sendEvent(self, mode, state, noEventSend);	
	if mode==1 then
		if state then
			self:playAnimation("rightDoor", 1, nil, true);
			self.rd = true;
		else
			self:playAnimation("rightDoor", -1, nil, true);
			self.rd = false;
		end;
	elseif mode==2 then
		if state then
			self:playAnimation("leftDoor", 1, nil, true);
			self.ld = true;
		else
			self:playAnimation("leftDoor", -1, nil, true);
			self.ld = false;
		end;
	elseif mode==3 then
		if state then
			self:playAnimation("backWindow", 1, nil, true);
			self.bw = true;
		else
			self:playAnimation("backWindow", -1, nil, true);
			self.bw = false;
		end;
	elseif mode==4 then
		self.tf = not self.tf	
		setVisibility(self.frontLeft,state)
		setVisibility(self.frontRight,state)
	elseif mode==5 then
		self.tb = not self.tb
		setVisibility(self.backLeft,state)
		setVisibility(self.backRight,state)
	end;
end;

function Ford8340:readStream(streamId, connection)
	self.rd = streamReadBool(streamId);
	self.ld = streamReadBool(streamId);
	self.bw = streamReadBool(streamId);
end;

function Ford8340:writeStream(streamId, connection)
    streamWriteBool(streamId, self.rd);
    streamWriteBool(streamId, self.ld);
	streamWriteBool(streamId, self.bw);
end;

function Ford8340:loadFromAttributesAndNodes(xmlFile, key, resetVehicles)
	if not resetVehicles then
		self.rd = Utils.getNoNil(getXMLBool(xmlFile, key.."#rd"),false);
		self.ld = Utils.getNoNil(getXMLBool(xmlFile, key.."#ld"),false);
		self.bw = Utils.getNoNil(getXMLBool(xmlFile, key.."#bw"),false);
		self.tf = Utils.getNoNil(getXMLBool(xmlFile, key.."#tf"),false);
		self.tb = Utils.getNoNil(getXMLBool(xmlFile, key.."#tb"),false);
		self.showTKHelp = Utils.getNoNil(getXMLBool(xmlFile, key.."#showTKHelp"),false);
		
		if self.tf then
			setVisibility(self.frontLeft,true)
			setVisibility(self.frontRight,true)
		end;
		if self.tb then
			setVisibility(self.backLeft,true)
			setVisibility(self.backRight,true)
		end;
		if self.rd then
			self:playAnimation("rightDoor", 100, nil, true);
		end;
		if self.ld then
			self:playAnimation("leftDoor", 100, nil, true);
		end;
		if self.bw then
			self:playAnimation("backWindow", 100, nil, true);
		end;
	end;
	
	return BaseMission.VEHICLE_LOAD_OK;
end;

function Ford8340:getSaveAttributesAndNodes(nodeIdent)
	local attributes = 'rd="'..tostring(self.rd)..
	'" ld="'..tostring(self.ld)..
	'" bw="'..tostring(self.bw)..
	'" tf="'..tostring(self.tf)..
	'" tb="'..tostring(self.tb)..
	'" showTKHelp="'..tostring(self.showTKHelp).. '"';
	return attributes;
end;
